package comaList ;

import java.util.NoSuchElementException ;


/**
 * Klasse fr einfach verkettete Listen mit Head-Dummy
 */
public class DummyList
{
   private class ListNode                // quasi struct
   {
   /***  Daten  ***/

      public Object   obj ;
      public ListNode next ;

   /***  Konstruktoren  ***/

      public ListNode ( )
      {
         obj  = null ;
         next = null ;
      }

      public ListNode ( Object myObj )
      {
         obj  = myObj ;
         next = null ;
      }
   }  // class ListNode

/***  Daten  ***/

   private ListNode _head ;              // Referenz auf ersten Knoten
   private ListNode _curr ;              // Referenz auf akt. Knoten

/***  Konstruktoren  ***/

// default-Konstruktor
   public DummyList ( )
   {
      _head = new ListNode() ;
      _curr = null ;
   }

// Kopierkonstruktor
   public DummyList ( DummyList myList )
   {
      this() ;                                             // ruft DummyList()

      ListNode tail = _head ;

      for ( myList.reset() ;  ! myList.isAtEnd() ;  myList.increment() )
          tail = tail.next = new ListNode( myList.currentData() ) ;
 
   }  // end DummyList()

/***  get-Methoden  ***/

// ist Liste leer?
   public boolean isEmpty ( )
   {
      return ( _head.next == null ) ;
   }

// steht akt. Knoten am Listenende?
   public boolean isAtEnd ( )
   {
      return ( _curr == null ) ;
   }

// gibt Objekt des akt. Knotens aus
   public Object currentData ( )
      throws NoSuchElementException
   {
      if ( isAtEnd() )
	 throw new NoSuchElementException( "No current list node!" ) ;

      return _curr.obj ;
   }
    
// gibt aktuelle Anzahl Elemente in der Liste zurck
   public int length ( )
   {
      int len = 0 ;

      for ( reset() ;  ! isAtEnd() ;  increment() )
	 ++len ;

      return len ;

   }  // end length()

/***  set-Methoden  ***/

// akt. Knoten auf Anfang setzen
   public void reset ( )
   {
      _curr = _head.next ;
   }

// rckt akt. Knoten ein Element weiter
   public void increment ( )
   {
      if ( ! isAtEnd() )                         // bleibt sonst am Ende stehen
	 _curr = _curr.next ;
   }

// fgt neuen Knoten am Anfang der Liste ein
   public void insert ( Object obj )
   {
      ListNode newNode = new ListNode( obj ) ;     // constructor for ListNode

      newNode.next = _head.next ;
      _head.next   = newNode ;
   }
    
// nimmt alle Knoten mit geg. Objekt aus der Liste
   public void remove ( Object obj )
   {
      ListNode lastNode = _head ;

      for ( reset() ;  ! isAtEnd() ;  increment() )
      {
	 if ( obj.equals( _curr.obj ) )
	    lastNode.next = _curr.next ;

	 lastNode = _curr ;
      }
   }  // end remove()

/***  Umwandlungsmethoden  ***/

// wandelt Liste in String der Objekte um
   public String toString ( )
   {
      String outstr = "" ;

      for ( reset() ;  ! isAtEnd() ;  increment() )
         outstr += currentData().toString() ;

      return outstr ;

   }  // end toString()

/***  main-Methode  **/

// dient hier zum Test der Methoden
   public static void main ( String args[] )
   {
      DummyList myList = new DummyList() ;

      for ( int i = 0 ;  i < 10 ;  ++i )
	 myList.insert( " " + i ) ;
      System.out.println( "myList  = " + myList ) ;

      DummyList secList = new DummyList( myList ) ;
      secList.remove( " 5" ) ;
      System.out.println( "secList = " + secList ) ;

   }  // end main()

}  // class DummyList
